using System;
using UnityEngine;

namespace Syntriax.Modules.Trigger
{
    public class Trigger : MonoBehaviour, ITrigger
    {
        public Action<bool> OnTriggered { get; set; } = null;

        private bool _isTrigerred = false;
        public bool IsTrigerred
        {
            get => _isTrigerred;
            protected set
            {
                if (value == _isTrigerred)
                    return;

                _isTrigerred = value;
                OnTriggered?.Invoke(value);
            }
        }
    }
}
